<template>
  <div class="contact">
    <main>
      <!-- <HeaderSignup/> -->
      <div class="register-user-section container">
        <!-- login section header -->
        <div class="main-title">
          <h1>
            Inscrivez-vous sur
            <span class="color-red"/>Socializer.
          </h1>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.</p>
        </div>

        <form class="register-user-form" @submit.prevent="signUp">
          <div class="row">
            <div class="col-md-6 col-xs-12">
              <div class="form-group">
                <label for="inputLastName">LastName</label>
                <input v-model="lastName" type="text" id="inputLastName" class="form-control" placeholder="lastName" required>
              </div>
            </div>

            <div class="col-md-6 col-xs-12">
              <div class="form-group">
                <label for="inputFirstName">First name</label>
                <input v-model="firstName" type="text" id="inputFirstName" class="form-control" placeholder="FirstName" required>
              </div>
            </div>

            <div class="col-md-6 col-xs-12">
              <div class="form-group">
                <label for="inputUserName">Nom d'utilisateur</label>
                <input v-model="username" type="text" id="inputUserName" class="form-control" placeholder="username" required
                      maxlength="180" pattern=".{5,}" title="Au moins 5 caractéres"> 
              </div>
            </div>

            <div class="col-md-6 col-xs-12">
              <div class="form-group">
                <label for="inputEmail" >Email</label>
                <input v-model="email" type="email" id="inputEmail" class="form-control" placeholder="Email" required>
              </div>
            </div>

            <div class="col-md-6 col-xs-12">
              <div class="form-group">
                <label for="inputPassword">Mot de passe</label>
                <input v-model="password" type="password" id="inputPassword" class="form-control" placeholder="password" required>
                <p
                  class="help-block"
                >Au moins 6 caractéres, avec une majuscule, une minuscule et un chiffre</p>
              </div>
            </div>
            
            <button class="btn btn-lg btn-primary btn-block" type="submit">Inscrivez vous</button>
            <div class="alert alert-danger" v-if="error">{{ error }}</div>

            </div>
          </form>
      </div>
    </main>
  </div>

</template>

<script>
import { mapGetters } from 'vuex'
export default {
  name: 'SignUp',
  data () {
    return {
      lastName: '', 
      firstName: '', 
      email: '',
      username: '',
      password: '',
      error: false
    }
  },
  created () {
    this.checkCurrentLogin()
  },
  updated () {
      this.checkCurrentLogin()
  },
  methods: {
    checkCurrentLogin () {
        if (this.currentUser) {
            console.log(this.currentUser)
            this.$router.replace(this.$route.query.redirect || '/dashboard')
        }
    },
    
    signUp () {
        this.$http.post('/signup', { lastName: this.lastName, firstName: this.firstName, email: this.email, username: this.username, password: this.password})
        .then(request => this.signUpSuccessful(request))
        .catch(() => this.signUpFail())
    },

    signUpSuccessful (req) {
      console.log(req)
    this.$store.dispatch('signup')
    this.$router.replace(this.$route.query.redirect || '/login')
    },

    signUpFail () {
    this.error = 'signUp failed!'
    this.$store.dispatch('logout')
    delete localStorage.token
    },
  },
  computed: {
    ...mapGetters({ currentUser: 'currentUser' })
  },
}
</script>